﻿using System;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows;
using System.Windows.Data;
using Infragistics.Controls.Grids;

namespace GridsCell
{
    public partial class MainWindow : Window
    {
        private readonly ObservableCollection<Data> collection;
        private ICollectionView defaultView;

        public MainWindow()
        {
            InitializeComponent();
            collection = new ObservableCollection<Data>();
            collection.CollectionChanged += CollectionOnCollectionChanged;
        }

        private void CollectionOnCollectionChanged(object sender, NotifyCollectionChangedEventArgs notifyCollectionChangedEventArgs)
        {
            Sort();
        }

        private void ApplyLayout(object sender, RoutedEventArgs e)
        {
            grid.Columns.Clear();
            grid.Columns.Add(new TextColumn() { Key = "Data1", IsSorted = SortDirection.Descending,  });
            grid.Columns.Add(new TextColumn() { Key = "Data2" });

            
            defaultView = CollectionViewSource.GetDefaultView(collection);
            grid.ItemsSource = defaultView;

        }
        private void AddItems(object sender, RoutedEventArgs e)
        {
            collection.Add(new Data() { Data1 = "Item 1"});
            collection.Add(new Data() { Data1 = "Item 2" });
            collection.Add(new Data() { Data1 = "Item 3" });
            Sort();
        }

        public void Sort()
        {
            var t = grid.Columns[0] as TextColumn;
            t.IsSorted = SortDirection.Ascending;
        }
    }
    public class Data
    {
        public String Data1{ get; set; }
        public String Data2 { get; set; }
        public String Data3 { get; set; }
        public String Data4 { get; set; }
    }
}
